package cx.ath.jbzdak.wyklad1.table;

import eu.javaspecialists.tjsn.gui.TristateCheckBox;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;
import java.awt.*;

/**
 * Created by: Jacek Bzdak
 */


public class CheckboxRenderer implements TableCellRenderer{

   private final Border noFocusBorder = new EmptyBorder(1, 1, 1, 1);

   private final TristateCheckBox checkBox = new TristateCheckBox("");

   public CheckboxRenderer() {
      checkBox.setHorizontalAlignment(SwingConstants.CENTER);
   }

   public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
                                                  boolean hasFocus, int row, int column) {
      fixBorder(table, value, isSelected, hasFocus, row, column);
      if (value == null){
         checkBox.setIndeterminate();
      }else{
         checkBox.setSelected((Boolean) value);
      }
      return checkBox;
   }



   public void fixBorder(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column){
      if (isSelected) {
         checkBox.setForeground(table.getSelectionForeground());
         checkBox.setBackground(table.getSelectionBackground());
      }
      else {
         checkBox.setForeground(table.getForeground());
         checkBox.setBackground(table.getBackground());
      }


      if (hasFocus) {
         checkBox.setBorder(UIManager.getBorder("Table.focusCellHighlightBorder"));
      } else {
         checkBox.setBorder(noFocusBorder);
      }
   }

}
