package cx.ath.jbzdak.wyklad1.table;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import java.awt.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Created by: Jacek Bzdak
 */
public class TableFrame2 extends JFrame {


   public TableFrame2() throws HeadlessException {

      CustomTableModel model = new CustomTableModel();
      
      model.addStudents(Database.getStudentsFromDatabase());

      JTable view = new JTable(model);

      this.add(new JScrollPane(view));

      setDefaultCloseOperation(DISPOSE_ON_CLOSE);

   }

   public static void main(String[] args) throws Exception{
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            TableFrame2 tf = new TableFrame2();
            tf.setSize(640, 480);
            tf.setVisible(true);
         }
      });
   }
}


      class CustomTableModel extends AbstractTableModel{

         List<Student> list = new ArrayList<Student>();

         public int getRowCount() {
            return list.size();
         }

         public int getColumnCount() {
            return 4;
         }

         public Object getValueAt(int rowIndex, int columnIndex) {
            switch (columnIndex){
               case 0:
                  return list.get(rowIndex).getName();
               case 1:
                  return list.get(rowIndex).getSurname();
               case 2:
                  return list.get(rowIndex).getMark();
               case 3:
                  return list.get(rowIndex).getLikesJava();
               default:
                  throw new IllegalStateException();
            }
         }

   @Override
   public String getColumnName(int column) {
      switch (column){
         case 0:
            return "Imię";
         case 1:
            return "Nazwisko";
         case 2:
            return "Ocena";
         case 3:
            return "Czy lubi javę";
         default:
            throw new IllegalStateException();
      }
   }

   public void addStudent(Student student){
      list.add(student);
      fireTableRowsInserted(list.size()-1, list.size());
   }

   public void addStudents(Collection<Student> students){
      list.addAll(students);
      fireTableRowsInserted(list.size()-students.size(), list.size());
   }
}